/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1994 Electrotechnical Laboratry (ETL), AIST, MITI

Permission to use, copy, modify, and distribute this material for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and
that the name of ETL not be used in advertising or publicity pertaining
to this material without the specific, prior written permission of an
authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:	pop.c (POP proxy)
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	941008	created
//////////////////////////////////////////////////////////////////////#*/
#include <stdio.h>
#include "delegate.h"
extern char *fgetsTIMEOUT();
extern char *getClientUserMbox();

typedef struct {
	char	*name;
	int	 resp;
} CommandSpec;

#define NULL_BODY	0
#define WITH_BODY	1
#define IN_RFC822	2
#define RESPFLAGS	(WITH_BODY|IN_RFC822)
#define NULL_BODY_IFARG	4

static CommandSpec pop_command[] = {
	/* MINIMAL POP3 COMMANDS */
	{ "USER"},
	{ "PASS"},
	{ "QUIT"},
	{ "STAT"},
	{ "LIST", WITH_BODY|NULL_BODY_IFARG },
	{ "RETR", WITH_BODY|IN_RFC822 },
	{ "DELE"},
	{ "NOOP"},
	{ "RSET"},

	/* OPTIONAL POP3 COMMANDS */
	{ "APOP"},
	{ "UIDL", WITH_BODY|NULL_BODY_IFARG },
	{ "TOP",  WITH_BODY|IN_RFC822 },

	/* private extension ? */
	{ "LAST"},
	{ "RPOP"},
	0
};

extern char *wordscan();
static change_server(Conn,fc,tc,vp,nextUSER)
	Connection *Conn;
	FILE *fc,*tc;
	char *vp;
	char *nextUSER;
{	char userhost[1024],*dp,user[256],hostport[256],host[256],tmp[1024];
	int port;

	wordscan(vp,userhost);

	if( strchr(userhost,'@') == NULL )
	if( dp = strrchr(userhost,'%') )
		*dp = '@'; /* from user%host1%host2 to user%host1@host2 */

	if( sscanf(userhost,"%[^@]@%s",user,hostport) == 2 ){
		if( dp = strrchr(user,'%') )
			*dp = '@';
		sprintf(userhost,"//%s/%s",hostport,user);
	}
	mount_url_to("GET",userhost);
	if( strncasecmp(userhost,"pop:",4) == 0 ){
		strcpy(tmp,userhost+4);
		strcpy(userhost,tmp);
	}
	if( sscanf(userhost,"//%[^/]/%s",hostport,user) == 2 ){
		port = 0;
		sscanf(hostport,"%[^:]:%d",host,&port);
		set_realserver(Conn,"pop",host,port);
		service_pop1(Conn,user,nextUSER);
		return 1;
	} 
	return 0;
}

static ProxyPOP(Conn)
	Connection *Conn;
{	char myhost[256];
	FILE *tc,*fc;
	char req[1024],com[1024],*vp;

	fc = fdopen(FromC,"r");
	tc = fdopen(ToC,"w");

	ClientIF_name(Conn,FromC,myhost);
	fprintf(tc,"+OK Proxy-POP server (%s) at %s starting.\r\n",
		DELEGATE_version(),myhost);
	fflush(tc);

	while( fgetsTIMEOUT(req,sizeof(req),fc) != NULL ) GOT: {
		vp = wordscan(req,com);
		if( strcaseeq(com,"USER") ){
			sv1log("POP C-S: %s",req);
			req[0] = 0;
			if( change_server(Conn,fc,tc,vp,req) ){
				if( req[0] )
					goto GOT;
				else	break;
			}
			fprintf(tc,"-ERR USER username@hostname is expected.\r\n");
		}else
		if( strcaseeq(com,"QUIT") ){
			fprintf(tc,"+OK bye.\r\n");
			fflush(tc);
			break;
		}else{
			fprintf(tc,"-ERR Unknown command: \"%s\"\r\n",com);
		}
		fflush(tc);
	}
	fclose(tc);
	fclose(fc);
}
service_pop(Conn)
	Connection *Conn;
{
	if( isMYSELF(DST_HOST) )
		return ProxyPOP(Conn);
	else	return service_pop1(Conn,NULL,NULL);
}
static closeServer(ts,fs)
	FILE *ts,*fs;
{	char resp[1024];

	fputs("QUIT\r\n",ts);
	fflush(ts);
	if( fgets(resp,sizeof(resp),fs) != NULL )
		sv1log("%s",resp);
	fclose(ts);
	fclose(fs);
}
service_pop1(Conn,user,nextUSER)
	Connection *Conn;
	char *user;
	char *nextUSER;
{	FILE *fc,*tc,*ts,*fs;
	char req[256],com[256],argb[256],arg[256];
	char *acom,banner[1024],resp[1024];
	int ri,body;
	char timestamp[256],ch,*sp,*dp;
	char userbuf[256],pass[256];
	int APOPforUSERPASS;

	if( connect_to_serv(Conn,FromC,ToC,0) < 0 )
		return;

	fc = fdopen(dup(FromC),"r");
	tc = fdopen(dup(ToC),"w");
	ts = fdopen(ToS,"w");
	fs = fdopen(FromS,"r");

	if( fgets(resp,sizeof(resp),fs) == NULL )
		goto EXIT;

	if( *resp != '+' ){
		fputs(resp,tc);
		fflush(tc);
		goto EXIT;
	}

	strcpy(banner,resp);
	dp = timestamp;
	if( sp = strchr(banner,'<') )
	for(; ch = *sp; sp++ ){
		*dp++ = ch;
		if( ch == '>' )
			break;
	}
	*dp = 0;
	if( strchr(timestamp,'@') != NULL && strtailchr(timestamp) == '>' )
		sv1log("#### BANNER TIMESTAMP for APOP: %s\n",timestamp);
	else	timestamp[0] = 0;

	if( user != NULL && timestamp[0] ){
		sprintf(resp,"+OK enter password for APOP/DeleGate: %s",
			banner);
	}else{
		if( *resp == '+' && user != NULL ){
			sprintf(req,"USER %s\r\n",user);
			if( fputs(req,ts) == EOF )
				goto EXIT;
			fflush(ts);
			if( fgets(resp,sizeof(resp),fs) == NULL )
				goto EXIT;
		}
	}
	if( fputs(resp,tc) == EOF )
		goto EXIT;
	fflush(tc);
	if( *resp != '+' )
		goto EXIT;

	for(;;){
		/* relay unexpected signing off message
		 * and other ? notification messages ?
		 */
		while( 0 < fPollIn(fs,1) ){
			if( fgets(resp,sizeof(resp),fs) == NULL )
				break;
			fputs(resp,tc);
		}
		fflush(tc);

		fgets(req,sizeof(req),fc);
		if( *req == '\r' || *req == '\n' )
			continue;

		sp = wordscan(req,com);
		if( *sp != 0 ){
			dp = arg;
			for( sp++; ch = *sp; sp++ ){
				if( ch == '\r' || ch == '\n' )
					break;
				*dp++ = ch;
			}
			*dp = 0;
		}else	arg[0] = 0;

		if( strcasecmp(com,"USER") == 0 )
			sv1log("POP C-S: %s",req);
		else
		if( strcasecmp(com,"PASS") == 0 )
			Verbose("POP C-S: PASS ******\r\n");
		else	Verbose("POP C-S: %s",req);

		if( strcasecmp(com,"USER") == 0 ){
			if( nextUSER != NULL ){
				closeServer(ts,fs); ts = fs = NULL;
				strcpy(nextUSER,req);
				goto EXIT;
			}
			if( user != NULL && timestamp[0] ){
				closeServer(ts,fs); ts = fs = NULL;
				goto EXIT;
			}
			strcpy(userbuf,arg);
			user = userbuf;
			if( timestamp[0] ){
				fprintf(tc,"+OK enter password for APOP/DeleGate.\r\n");
				fflush(tc);
				continue;
			}
		}

		APOPforUSERPASS = 0;
		if( strcasecmp(com,"PASS") == 0 )
		if( user != NULL && timestamp[0] ){
			strcpy(com,"APOP");
			strcpy(pass,arg);
			sprintf(argb,"%s%s",timestamp,pass);
			toMD5(argb,arg);
			sprintf(req,"%s %s %s\r\n",com,user,arg);
			sv1log("#### %s",req);
			APOPforUSERPASS = 1;
		}

		for( ri = 0; acom = pop_command[ri].name; ri++ ){
			if( strcaseeq(com,acom) )
				break;
		}
		fputs(req,ts);
		fflush(ts);

		if( fgets(resp,sizeof(resp),fs) == NULL )
			goto EXIT;

		if( *resp == '-' && APOPforUSERPASS ){
			sv1log("POP-AUTH: APOP for USER+PASS failed: %s",resp);
			sv1log("POP-AUTH: retrying with USER+PASS.\n");
			closeServer(ts,fs); ts = fs = NULL;
			if( connect_to_serv(Conn,FromC,ToC,0) < 0 )
				goto EXIT;

			ts = fdopen(ToS,"w");
			fs = fdopen(FromS,"r");
			if( fgets(resp,sizeof(resp),fs) == NULL )
				goto EXIT;
			fprintf(ts,"USER %s\r\n",user);
			fflush(ts);
			if( fgets(resp,sizeof(resp),fs) == NULL )
				goto EXIT;
			fprintf(ts,"PASS %s\r\n",pass);
			fflush(ts);
			if( fgets(resp,sizeof(resp),fs) == NULL )
				goto EXIT;
		}

		body = pop_command[ri].resp;
		if( body && arg[0] ){
			if( body & NULL_BODY_IFARG )
				body = NULL_BODY;
		}

		if( body && *resp == '+' )
		if( (body & RESPFLAGS) == (WITH_BODY|IN_RFC822) ) 
		if( filter_withCFI(Conn,XF_FTOCL) )
			putMESSAGEline(tc,"mime",com);

		if( fputs(resp,tc) == EOF )
			goto EXIT;

		if( strcasecmp(com,"PASS") == 0 )
			Verbose("POP S-C[%d:%d]: PASS ******\r\n",ri,body);
		else	Verbose("POP S-C[%d:%d]: %s",ri,body,resp);

		if( body && *resp == '+' ){
			switch( body & RESPFLAGS ){
				case WITH_BODY | IN_RFC822:
					PGPdecodeMIME(fs,tc,NULL,0xFF,1,0);
					break;
				case WITH_BODY:
					thruRESP(fs,tc);
					break;
			}
		}
		fflush(tc);
		if( strcaseeq(com,"QUIT") )
			goto EXIT;

		if( user != NULL )
		if( strcaseeq(com,"PASS") || strcaseeq(com,"APOP") ){
			char clnt[256],serv[256];
			char *cluser,clhost[256];
			char *getClientUserC();
			int clport;

			clport = getClientHostPort(Conn,clhost);
			if( (cluser = getClientUserC(Conn)) == NULL )
				cluser = "-";
			sprintf(clnt,"%s@%s:%d",cluser,clhost,clport);

			sprintf(serv,"%s@%s",user,DST_HOST);
			sv1log("%cPOP-LOGIN FROM %s TO %s\n",
				resp[0],clnt,serv);
			fputLog(Conn,"Login","%cPOP-LOGIN; from=%s; to=%s\n",
				resp[0],clnt,serv);
			LOG_flushall();
		}
	}

EXIT:
	if( ts != NULL ) fclose(ts);
	if( fs != NULL ) fclose(fs);
	if( tc != NULL ) fclose(tc);
	if( fc != NULL ) fclose(fc);
	return;
}
